﻿Namespace System

   ''' <summary>
   ''' eingegeben werden Separatoren eines Zahlenbereiches, zusammen mit Items. Die Items matchen dann auf alle Werte von (einschließlich) diesem Separator bis zum nächsthöheren. Das Smallest-Item muß logischerweise ohne Separator eingegeben werden. Die Klasse kann auch als Mini-Dictionary herhalten. Initialisierung mittm From-Auflistungs-Initialisierer
   ''' </summary>
   Public Class RangeSelector(Of TKey As IComparable, TValue) : Implements IEnumerable

      Private _Keys As New List(Of TKey)
      Private _Values As New List(Of TValue)

      Public Sub New(ByVal smallest As TValue)
         _Values.Add(smallest)
      End Sub

      ''' <summary> item will be associated with Values >= separator</summary>
      Public Sub Add(ByVal separator As TKey, ByVal item As TValue)
         Dim i = _Keys.BinarySearch(separator)
         If i < 0 Then i = i Xor -1
         _Keys.Insert(i, separator)
         _Values.Insert(i + 1, item)
      End Sub

      Default Public ReadOnly Property Item(ByVal key As TKey) As TValue
         Get
            Dim i = _Keys.BinarySearch(key)
            Return _Values(If(i < 0, i Xor -1, i + 1))
         End Get
      End Property

      Public Function GetEnumerator() As Collections.IEnumerator Implements Collections.IEnumerable.GetEnumerator
         Throw New NotImplementedException
      End Function
   End Class
End Namespace