
Namespace System

   Public Class MyStopWatch
      'Use: enclose what you want to benchmark in a While MyStopWatch.Until() - loop. It will display, how
      '! often the enclosed stuff was executed
      Private Sub UntilDemo()
         While MyStopWatch.Until(1000, "Demo")
            Console.WriteLine("Demo, Text" & Now)
         End While
      End Sub

      Private Shared _Counter As Integer
      Private Shared _LastTick As Integer = Integer.MinValue

      Public Shared Function Until( _
            ByVal RunTime As Integer, Optional ByVal Msg As String = "MyStopWatch") As Boolean
         If Environment.TickCount < _LastTick Then
            _Counter += 1
         ElseIf _LastTick = Integer.MinValue Then
            _LastTick = Environment.TickCount + RunTime
            _Counter = 0
         Else
            Console.WriteLine(String.Concat(Msg, ": ", _Counter))
            _LastTick = Integer.MinValue
            Return False
         End If
         Return True
      End Function

   End Class
End Namespace