﻿Imports System.Collections.Generic
Imports System.Linq
Imports System.Data
Imports System.Data.Common
Imports System.ComponentModel
Imports System.Reflection
Imports System.Windows.Forms
Imports System.Text
Imports TableInf = System.[Set](Of System.Data.DataTable, System.IDisposable)

Namespace System.Data

   Partial Public Class DatasetAdapter

      <DebuggerDisplay("Table = {Table}")> _
      Public NotInheritable Class TableAdapter : Implements IDisposable

         Public Function Fill() As Integer
            Return FillTable(AllCommands(0), True)
         End Function

         Public Property Enable() As Boolean
            Get
               Return Table.Events.Enable
            End Get
            Set(ByVal value As Boolean)
               If value Then
                  'top-down DataTable-Events re-aktivieren
                  For Each tb In _ChildTables
                     tb.Events.Enable = value
                  Next
               Else
                  'bottom-up DataTable-Events deaktivieren
                  For I As Integer = _ChildTables.Length - 1 To 0 Step -1
                     _ChildTables(I).Events.Enable = value
                  Next
               End If
            End Set
         End Property

         Public Function FillTable(ByVal cmd As DbCommand, ByVal clearBeforeFill As Boolean) As Integer
            Enable = False
            Try
               If clearBeforeFill Then
                  For Each tb In _ChildTables
                     If tb.Rows.Count > 0 Then tb.Clear()
                  Next
               End If
               Adapter.SelectCommand = cmd
               Return Adapter.Fill(Table)
            Catch ex As ConstraintException
               For i = 0 To Table.Rows.Count - 1
                  If Table.Rows(i).HasErrors Then
                     Throw New ConstraintException( _
                        "Fehler in Zeile ".And(i, ": ", Table.Rows(i).RowError), ex)
                  End If
               Next
            Finally
               Enable = True
            End Try
         End Function

         Public Sub Dispose() Implements System.IDisposable.Dispose
            Adapter.DisposeManaged(True).AndAlso(AllCommands.Cast(Of IDisposable))
         End Sub

      End Class   'TableAdapter
   End Class 'Partial DatasetAdapter

End Namespace
